---
title: 'Establishing a connection: The WebRTC perfect negotiation pattern'
slug: Web/API/WebRTC_API/Perfect_negotiation
tags:
  - API
  - Configure
  - Connection
  - Connectivity
  - Guide
  - Intermediate
  - Negotiation
  - Perfect Negotiation
  - Setup
  - Startup
  - WebRTC
  - WebRTC API
---
<p>{{APIRef("WebRTC")}}</p>

<p>Because <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> doesn't mandate a specific transport mechanism for signaling during the negotiation of a new peer connection, it's highly flexible. However, despite that flexibility in transport and communication of signaling messages, there's still a recommended design pattern you should follow when possible, known as <strong>perfect negotiation</strong>. <span class="seoSummary">This article introduces WebRTC perfect negotiation, describing how it works and why it's the recommended way to negotiate a WebRTC connection between peers, and provides sample code to demonstrate the technique.</span></p>

<p>After the first deployments of WebRTC-capable browsers, it was realized that parts of the negotiation process were more complicated than they needed to be for typical use cases. This was due to a small number of issues with the API and some potential race conditions that needed to be prevented. These issues have since been addressed, letting us simplify our WebRTC negotiation significantly. The perfect negotiation pattern is an example of the ways in which negotiation have improved since the early days of WebRTC.</p>

<h2 id="Perfect_negotiation_concepts">Perfect negotiation concepts</h2>

<p>Perfect negotiation makes it possible to seamlessly and completely separate the negotiation process from the rest of your application's logic. Negotiation is an inherently asymmetric operation: one side needs to serve as the "caller" while the other peer is the "callee." The perfect negotiation pattern smooths this difference away by separating that difference out into independent negotiation logic, so that your application doesn't need to care which end of the connection it is. As far as your application is concerned, it makes no difference whether you're calling out or receiving a call.</p>

<p>The best thing about perfect negotiation is that the same code is used for both the caller and the callee, so there's no repetition or otherwise added levels of negotiation code to write.</p>

<p>Perfect negotiation works by assigning each of the two peers a role to play in the negotiation process that's entirely separate from the WebRTC connection state:</p>

<ul>
 <li>A <strong>polite</strong> peer, which uses ICE rollback to prevent collisions with incoming offers. A polite peer, essentially, is one which may send out offers, but then responds if an offer arrives from the other peer with "Okay, never mind, drop my offer and I'll consider yours instead."</li>
 <li>An <strong>impolite</strong> peer, which always ignores incoming offers that collide with its own offers. It never apologizes or gives up anything to the polite peer. Any time a collision occurs, the impolite peer wins.</li>
</ul>

<p>This way, both peers know exactly what should happen if there are collisions between offers that have been sent. Responses to error conditions become far more predictable.</p>

<p>How you determine which peer is polite and which is impolite is generally up to you. It could be as simple as assigning the polite role to the first peer to connect to the signaling server, or you could do something more elaborate like having the peers exchange random numbers and assigning the polite role to the winner. However you make the determination, once these roles are assigned to the two peers, they can then work together to manage signaling in a way that doesn't deadlock and doesn't require a lot of extra code to manage.</p>

<p>An important thing to keep in mind is this: the roles of caller and callee can switch during perfect negotiation. If the polite peer is the caller and it sends an offer but there's a collision with the impolite peer, the polite peer drops its offer and instead replies to the offer it has received from the impolite peer. By doing so, the polite peer has switched from being the caller to the callee!</p>

<h2 id="Implementing_perfect_negotiation">Implementing perfect negotiation</h2>

<p>Let's take a look at an example that implements the perfect negotiation pattern. The code assumes that there's a <code>SignalingChannel</code> class defined that is used to communicate with the signaling server. Your own code, of course, can use any signaling technique you like.</p>

<p>Note that this code is identical for both peers involved in the connection.</p>

<h3 id="Create_the_signaling_and_peer_connections">Create the signaling and peer connections</h3>

<p>First, the signaling channel needs to be opened and the {{domxref("RTCPeerConnection")}} needs to be created. The {{Glossary("STUN")}} server listed here is obviously not a real one; you'll need to replace <code>stun.myserver.tld</code> with the address of a real STUN server.</p>

<pre class="brush: js notranslate">const constraints = { audio: true, video: true };
const config = {
  iceServers: [{ urls: "stun:stun.mystunserver.tld" }]
};

const selfVideo = document.querySelector("video.selfview");
const remoteVideo = document.querySelector("video.remoteview");

const signaler = new SignalingChannel();
const pc = new RTCPeerConnection(config);
</pre>

<p>This code also gets the {{HTMLElement("video")}} elements using the classes "selfview" and "remoteview"; these will contain, respectively, the local user's self-view and the view of the incoming stream from the remote peer.</p>

<h3 id="Connecting_to_a_remote_peer">Connecting to a remote peer</h3>

<p>The <code>start()</code> function shown here can be called by either of the two end-points that want to talk to one another. It doesn't matter who does it first; the negotiation will just work.</p>

<pre class="brush: js notranslate">async function start() {
  try {
    const stream = await navigator.mediaDevices.getUserMedia(constraints);

    for (const track of stream.getTracks()) {
      pc.addTrack(track, stream);
    }
    selfVideo.srcObject = stream;
  } catch(err) {
    console.error(err);
  }
}
</pre>

<p>This isn't appreciably different from older WebRTC connection establishment code. The user's camera and microphone are obtained by calling {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}. The resulting media tracks are then added to the {{domxref("RTCPeerConnection")}} by passing them into {{domxref("RTCPeerConnection.addTrack", "addTrack()")}}. Then, finally, the media source for the self-view {{HTMLElement("video")}} element indicated by the <code>selfVideo</code> constant is set to the camera and microphone stream, allowing the local user to see what the other peer sees.</p>

<h3 id="Handling_incoming_tracks">Handling incoming tracks</h3>

<p>We next need to set up a handler for {{domxref("RTCPeerConnection.track_event", "track")}} events to handle inbound video and audio tracks that have been negotiatied to be received by this peer connection. To do this, we implement the {{domxref("RTCPeerConnection")}}'s {{domxref("RTCPeerConnection.ontrack", "ontrack")}} event handler.</p>

<pre class="brush: js notranslate">pc.ontrack = ({track, streams}) =&gt; {
  track.onunmute = () =&gt; {
    if (remoteVideo.srcObject) {
      return;
    }
    remoteVideo.srcObject = streams[0];
  };
};
</pre>

<p>When the <code>track</code> event occurs, this handler executes. Using <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment">destructuring</a>, the {{domxref("RTCTrackEvent")}}'s {{domxref("RTCTrackEvent.track", "track")}} and {{domxref("RTCTrackEvent.streams", "streams")}} properties are extracted. The former is either the video track or the audio track being received. The latter is an array of {{domxref("MediaStream")}} objects, each representing a stream containing this track (a track may in rare cases belong to multiple streams at once). In our case, this will always contain one stream, at index 0, because we passed one stream into <code>addTrack()</code> earlier.</p>

<p>We add an unmute event handler to the track, because the track will become unmuted once it starts receiving packets. We put the remainder of our reception code in there.</p>

<p>If we already have video coming in from the remote peer (which we can see if the remote view's <code>&lt;video&gt;</code> element's {{domxref("HTMLMediaElement.srcObject", "srcObject")}} property already has a value), we do nothing. Otherwise, we set <code>srcObject</code> to the stream at index 0 in the <code>streams</code> array.</p>

<h3 id="The_perfect_negotiation_logic">The perfect negotiation logic</h3>

<p>Now we get into the true perfect negotiation logic, which functions entirely independently from the rest of the application.</p>

<h4 id="Handling_the_negotiationneeded_event">Handling the negotiationneeded event</h4>

<p>First, we implement the {{domxref("RTCPeerConnection")}} event handler {{domxref("RTCPeerConnection.onnegotiationneeded", "onnegotiationneeded")}} to get a local description and send it using the signaling channel to the remote peer.</p>

<pre class="brush: js notranslate">let makingOffer = false;

pc.onnegotiationneeded = async () =&gt; {
  try {
    makingOffer = true;
    await pc.setLocalDescription();
    signaler.send({ description: pc.localDescription });
  } catch(err) {
    console.error(err);
  } finally {
    makingOffer = false;
  }
};
</pre>

<p>Note that <code>setLocalDescription()</code> without arguments automatically creates and sets the appropriate description based on the current {{domxref("RTCPeerConnection.signalingState", "signalingState")}}. The set description is either an answer to the most recent offer from the remote peer <em>or</em> a freshly-created offer if there's no negotiation underway. Here, it will be always be an <code>offer</code>, because the negotiationneeded event is only fired in <code>stable</code> state.</p>

<p>We set a Boolean variable, <code>makingOffer</code> to <code>true</code> to mark that we're preparing an offer. To avoid races, we'll use this value later instead of the signaling state to determine whether or not an offer is being processed because the value of {{domxref("RTCPeerConnection.signalingState", "signalingState")}} changes asynchronously, introducing a glare opportunity.</p>

<p>Once the offer has been created, set and sent (or an error occurs), <code>makingOffer</code> gets set back to <code>false</code>.</p>

<h4 id="Handling_incoming_ICE_candidates">Handling incoming ICE candidates</h4>

<p>Next, we need to handle the <code>RTCPeerConnection</code> event {{domxref("RTCPeerConnection.icecandidate_event", "icecandidate")}}, which is how the local ICE layer passes candidates to us for delivery to the remote peer over the signaling channel.</p>

<pre class="brush: js notranslate">pc.onicecandidate = ({candidate}) =&gt; signaler.send({candidate});</pre>

<p>This takes the <code>candidate</code> member of this ICE event and passes it through to the signaling channel's <code>send()</code> method to be sent over the signaling server to the remote peer.</p>

<h4 id="Handling_incoming_messages_on_the_signaling_channel">Handling incoming messages on the signaling channel</h4>

<p>The last piece of the puzzle is code to handle incoming messages from the signaling server. That's implemented here as an <code>onmessage</code> event handler on the signaling channel object. This method is invoked each time a message arrives from the signaling server.</p>

<pre class="brush: js notranslate">let ignoreOffer = false;

signaler.onmessage = async ({ data: { description, candidate } }) =&gt; {
  try {
    if (description) {
      const offerCollision = (description.type == "offer") &amp;&amp;
                             (makingOffer || pc.signalingState != "stable");

      ignoreOffer = !polite &amp;&amp; offerCollision;
      if (ignoreOffer) {
        return;
      }

      await pc.setRemoteDescription(description);
      if (description.type == "offer") {
        await pc.setLocalDescription();
        signaler.send({ description: pc.localDescription })
      }
    } else if (candidate) {
      try {
        await pc.addIceCandidate(candidate);
      } catch(err) {
        if (!ignoreOffer) {
          throw err;
        }
      }
    }
  } catch(err) {
    console.error(err);
  }
}</pre>

<p>Upon receiving an incoming message from the <code>SignalingChannel</code> through its <code>onmessage</code> event handler, the received JSON object is destructured to obtain the <code>description</code> or <code>candidate</code> found within. If the incoming message has a <code>description</code>, it's either an offer or an answer sent by the other peer.</p>

<p>If, on the other hand, the message has a <code>candidate</code>, it's an ICE candidate received from the remote peer as part of <a href="/en-US/docs/Web/API/RTCPeerConnection/canTrickleIceCandidates">trickle ICE</a>. The candidate is destined to be delivered to the local ICE layer by passing it into {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}}.</p>

<h5 id="On_receiving_a_description">On receiving a description</h5>

<p>If we received a <code>description</code>, we prepare to respond to the incoming offer or answer. First, we check to make sure we're in a state in which we can accept an offer. If the connection's signaling state isn't <code>stable</code> or if our end of the connection has started the process of making its own offer, then we need to look out for offer collision.</p>

<p>If we're the impolite peer, and we're receiving a colliding offer, we return without setting the description, and instead set <code>ignoreOffer</code> to <code>true</code> to ensure we also ignore all candidates the other side may be sending us on the signaling channel belonging to this offer. Doing so avoids error noise since we never informed our side about this offer.</p>

<p>If we're the polite peer, and we're receiving a colliding offer, we don't need to do anything special, because our existing offer will automatically be rolled back in the next step.</p>

<p>Having ensured that we want to accept the offer, we set the remote description to the incoming offer by calling {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}. This lets WebRTC know what the proposed configuration of the other peer is. If we're the polite peer, we will drop our offer and accept the new one.</p>

<p>If the newly-set remote description is an offer, we ask WebRTC to select an appropriate local configuration by calling the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} without parameters. This causes <code>setLocalDescription()</code> to automatically generate an appropriate answer in response to the received offer. Then we send the answer through the signaling channel back to the first peer.</p>

<h5 id="On_receiving_an_ICE_candidate">On receiving an ICE candidate</h5>

<p>On the other hand, if the received message contains an ICE candidate, we deliver it to the local {{Glossary("ICE")}} layer by calling the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}}. If an error occurs and we've ignored the most recent offer, we also ignore any error that may occur when trying to add the candidate.</p>

<h2 id="Making_negotiation_perfect">Making negotiation perfect</h2>

<p>If you're curious what makes perfect negotiation so... perfect... this section is for you. Here, we'll look at each change made to the WebRTC API and to best practice recommendations to make perfect negotiation possible.</p>

<h3 id="Glare-free_setLocalDescription">Glare-free setLocalDescription()</h3>

<p>In the past, the {{domxref("RTCPeerConnection.negotiationneeded_event", "negotiationneeded")}} event was easily handled in a way that was susceptible to glare—that is, it was prone to collisions, where both peers could wind up attempting to make an offer at the same time, leading to one or the other peers getting an error and aborting the connection attempt.</p>

<h4 id="The_old_way">The old way</h4>

<p>Consider this {{domxref("RTCPeerConnection.onnegotiationneeded", "onnegotiationneeded")}} event handler:</p>

<pre class="brush: js example-bad notranslate">pc.onnegotiationneeded = async () =&gt; {
  try {
    await pc.setLocalDescription(await pc.createOffer());
    signaler.send({description: pc.localDescription});
  } catch(err) {
    console.error(err);
  }
};
</pre>

<p>Because the {{domxref("RTCPeerConnection.createOffer", "createOffer()")}} method is asynchronous and takes some time to complete, there's time in which the remote peer might attempt to send an offer of its own, causing us to leave the <code>stable</code> state and enter the <code>have-remote-offer</code> state, which means we are now waiting for a response to the offer. But once it receives the offer we just sent, so is the remote peer. This leaves both peers in a state in which the connection attempt cannot be completed.</p>

<h4 id="Perfect_negotiation_with_the_updated_API">Perfect negotiation with the updated API</h4>

<p>As shown in the section {{anch("Implementing perfect negotiation")}}, we can eliminate this problem by introducing a variable (here called <code>makingOffer</code>) which we use to indicate that we are in the process of sending an offer, and making use of the updated <code>setLocalDescription()</code> method:</p>

<pre class="brush: js example-good notranslate">let makingOffer = false;

pc.onnegotiationneeded = async () =&gt; {
  try {
    makingOffer = true;
    await pc.setLocalDescription();
    signaler.send({ description: pc.localDescription });
  } catch(err) {
    console.error(err);
  } finally {
    makingOffer = false;
  }
};
</pre>

<p>We set <code>makingOffer</code> immediately before calling <code>setLocalDescription()</code> in order to lock against interfering with sending this offer, and we don't clear it back to <code>false</code> until the offer has been sent to the signaling server (or an error has occurred, preventing the offer from being made). This way, we avoid the risk of offers colliding.</p>

<h3 id="Automatic_rollback_in_setRemoteDescription">Automatic rollback in setRemoteDescription()</h3>

<p>A key component to perfect negotiation is the concept of the polite peer, which always rolls itself back if it receives an offer while itself waiting for an answer to an offer. Previously, triggering rollback involved manually checking for rollback conditions and triggering the rollback manually, by setting the local description to one with the type <code>rollback</code>, like this:</p>

<pre class="brush: js notranslate">await pc.setLocalDescription({ type: "rollback" });</pre>

<p>Doing so returns the local peer to the <code>stable</code> {{domxref("RTCPeerConnection.signalingState", "signalingState")}} from whichever state it had previously been in. Since a peer can only accept offers when in the <code>stable</code> state, the peer has thus rescinded its offer and is ready to receive the offer from the remote (impolite) peer. As we'll see in a moment, there are problems with this approach, however.</p>

<h4 id="Perfect_negotiation_with_the_old_API">Perfect negotiation with the old API</h4>

<p>Using the previous API to implement incoming negotiation messages during perfect negotiation would look something like this:</p>

<pre class="brush: js example-bad notranslate">signaler.onmessage = async({data: { description, candidate }}) =&gt; {
  try {
    if (description) {
      if (description.type == "offer" &amp;&amp; pc.signalingState != "stable") {
        if (!polite) {
          return;
        }

        await Promise.all([
          pc.setLocalDescription({type: "rollback"}),
          pc.setRemoteDescription(description);
        ]);
      } else {
        await pc.setRemoteDescription(description);
      }

      if (description.type == "offer") {
        await pc.setLocalDescription(await pc.createAnswer());
        signaler.send({ description: pc.localDescription });
      }
    } else if (candidate) {
      try {
        await pc.addIceCandidate(candidate);
      } catch(err) {
        if (!ignoreOffer) {
          throw err;
        }
      }
    }
  } catch(err) {
    console.error(err);
  }
};</pre>

<p>Since rollback works by postponing changes until the next negotiation (which will begin immediately after the current one is finished), the polite peer needs to know when it needs to throw away a received offer if it's currently waiting for a reply to an offer it's already sent.</p>

<p>The code checks to see if the message is an offer, and if so, if the local signaling state isn't <code>stable</code>. If it's not stable, <em>and</em> the local peer is the polite one, we need to trigger rollback so we can replace the outgoing offer with the new incoming one. and these must both be completed before we can proceed with handling the received offer.</p>

<p>Since there isn't a single "roll back and use this offer instead", performing this change on the polite peer requires two steps, executed in the context of <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/all">Promise.all()</a></code>, which is used to ensure that both statements execute completely before continuing to handle the received offer. The first statement triggers rollback and the second sets the remote description to the received one, thus completing the process of replacing the previously <em>sent</em> offer with the newly <em>received</em> offer. The impolite peer has now become the callee instead of the caller.</p>

<p>Alll other descriptions received from the impolite peer are processed as normal, by passing them into {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}.</p>

<p>Finally, we process a received offer by calling <code>setLocalDescription()</code> to set our local description to the one returned by {{domxref("RTCPeerConnection.createAnswer", "createAnswer()")}}. Then that gets sent to the polite peer using the signaling channel.</p>

<p>If the incoming message is an ICE candidate rather than an SDP description, it's delivered to the ICE layer by passing it into the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}}. If an error occurs here and we didn't just discard an offer due to being the impolite peer during a collision, we <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/throw">throw</a></code> the error so the caller can handle it. Otherwise, we drop the error, ignoring it, since it doesn't matter in this context.</p>

<h4 id="Perfect_negotiation_with_the_updated_API_2">Perfect negotiation with the updated API</h4>

<p>The updated code takes advantage of the fact that you can now call {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} with no parameters so it just does the right thing for you, as well as the fact that <code>setRemoteDescription()</code> automatically rolls back if necessary. This lets us get rid of the need to use a <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">Promise</a></code> to keep the timing in order, since the rollback becomes an essentially atomic part of the <code>setRemoteDescription()</code> call.</p>

<pre class="brush: js example-good notranslate">let ignoreOffer = false;

signaler.onmessage = async ({ data: { description, candidate } }) =&gt; {
  try {
    if (description) {
      const offerCollision = (description.type == "offer") &amp;&amp;
                             (makingOffer || pc.signalingState != "stable");

      ignoreOffer = !polite &amp;&amp; offerCollision;
      if (ignoreOffer) {
        return;
      }

      await pc.setRemoteDescription(description);
      if (description.type == "offer") {
        await pc.setLocalDescription();
        signaler.send({ description: pc.localDescription });
      }
    } else if (candidate) {
      try {
        await pc.addIceCandidate(candidate);
      } catch(err) {
        if (!ignoreOffer) {
          throw err;
        }
      }
    }
  } catch(err) {
    console.error(err);
  }
}</pre>

<p>While the difference in code size is minor, and the complexity isn't reduced much either, the code is much, much more reliable. Let's take a dive into the code to see how it works now.</p>

<h5 id="On_receiving_a_description_2">On receiving a description</h5>

<p>In the revised code, if the received message is an SDP <code>description</code>, we check to see if it arrived while we're attempting to transmit an offer. If the received message is an <code>offer</code> <em>and</em> the local peer is the impolite peer, <em>and</em> a collision is occurring, we ignore the offer because we want to continue to try to use the offer that's already in the process of being sent. That's the impolite peer in action.</p>

<p>In any other case, we'll try instead to handle the incoming message. This begins by setting the remote description to the received <code>description</code> by passing it into {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}}. This works regardless of whether we're handling an offer or an answer since rollback will be performed automaticaly as needed.</p>

<p>At that point, if the received message is an <code>offer</code>, we use <code>setLocalDescription()</code> to create and set an appropriate local description, then we send it to the remote peer over the signaling server.</p>

<h5 id="On_receiving_an_ICE_candidate_2">On receiving an ICE candidate</h5>

<p>On the other hand, if the received message is an ICE candidate—indicated by the JSON object containing a <code>candidate</code> member—we deliver it to the local ICE layer by calling the {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}}. Errors are, as before, ignored if we have just discarded an offer.</p>

<h3 id="Explicit_restartIce_method_added">Explicit restartIce() method added</h3>

<p>The techniques previously used to trigger an <a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime#ICE_restart">ICE restart</a> while handling the event{{domxref("RTCPeerConnection.negotiationneeded_event", "negotiationneeded")}} have significant flaws. These flaws have made it difficult to safely and reliably trigger a restart during negotiation. The perfect negotiation improvements have fixed this by adding a new {{domxref("RTCPeerConnection.restartIce", "restartIce()")}} method to <code>RTCPeerConnection</code>.</p>

<h4 id="The_old_way_2">The old way</h4>

<p>In the past, if you encountered an ICE error and needed to restart negotiation, you might have done something like this:</p>

<pre class="brush: js example-bad notranslate">pc.onnegotiationneeded = async options =&gt; {
  await pc.setLocalDescription(await pc.createOffer(options));
  signaler.send({ description: pc.localDescription });
};
pc.oniceconnectionstatechange = () =&gt; {
  if (pc.iceConnectionState === "failed") {
    pc.onnegotiationneeded({ iceRestart: true });
  }
};
</pre>

<p>This has a number of reliability issues and outright bugs (such as failing if the {{domxref("RTCPeerConnection.iceconnectionstatechange_event", "iceconnectionstatechange")}} event fires when the signaling state isn't <code>stable</code>), but there was no way you could actually request an ICE restart other than by creating and sending an offer with the {{domxref("RTCOfferOptions.iceRestart", "iceRestart")}} option set to <code>true</code>. Sending the restart request thus required directly invoking the <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">negotiationneeded</span></font> event's handler. Getting it right was tricky at best, and was so easy to get wrong that bugs are common.</p>

<h4 id="Using_restartIce">Using restartIce()</h4>

<p>Now, you can use <code>restartIce()</code> to do this much more cleanly:</p>

<pre class="brush: js example-good notranslate">pc.onnegotiationneeded = async options =&gt; {
  await pc.setLocalDescription(await pc.createOffer(options));
  signaler.send({ description: pc.localDescription });
};
pc.oniceconnectionstatechange = () =&gt; {
  if (pc.iceConnectionState === "failed") {
    pc.restartIce();
  }
};</pre>

<p>With this improved technique, instead of directly calling <code>onnegotiationneeded</code> with options to trigger ICE restart, the <code>failed</code> <a href="/en-US/docs/Web/API/RTCPeerConnection/iceConnectionState">ICE connection state</a> calls {{domxref("RTCPeerConnection.restartIce", "restartIce()")}}. <code>restartIce()</code> tells the ICE layer to automatically add the <code>iceRestart</code> flag to the next ICE message sent. Problem solved!</p>

<h3 id="Rollback_no_longer_supported_in_the_pranswer_state">Rollback no longer supported in the pranswer state</h3>

<p>The last of the API changes that stand out is that you can no longer roll back when in either of the <code>have-remote-pranswer</code> or the <code>have-local-pranswer</code> states. Fortunately, when using perfect negotiation there's no need to do this anyway, since the situations that cause this are caught and prevented before rolling these back ever becomes necessary.</p>

<p>Thus, attempting to trigger rollback while in one of the two <code>pranswer</code> states will now throw an <code>InvalidStateError</code>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
</ul>
